Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | Friends | List of all members
TransformTable Class Reference

Stores the total set of VertexTransforms that the vertices in a particular GeomVertexData object might depend on. More...

`#include "transformTable.h"`

Inheritance diagram for TransformTable:

## Public Member Functions
| TransformTable (const TransformTable &copy)
size_t | add_transform (const VertexTransform *transform)
| Adds a new transform to the table and returns the index number of the new transform.
virtual int | complete_pointers (TypedWritable **plist, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().
virtual TypeHandle | force_init_type ()
UpdateSeq | get_modified (Thread *current_thread=Thread::get_current_thread()) const
size_t | get_num_transforms () const
const VertexTransform * | get_transform (size_t n) const
virtual TypeHandle | get_type () const
void | insert_transform (size_t n, const VertexTransform *transform)
bool | is_registered () const
void | operator= (const TransformTable &copy)
void | remove_transform (size_t n)
void | set_transform (size_t n, const VertexTransform *transform)
void | write (std::ostream &out) const
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static | CPT (TransformTable) register_table(const TransformTable *table)
static TypeHandle | get_class_type ()
static void | init_type ()
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type TransformTable.
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
| get_modified
| Returns a sequence number that's guaranteed to change at least when any VertexTransforms in the table change.
| get_num_transforms
| Returns the number of transforms in the table.
| get_transform
| Returns the nth transform in the table.
| insert_transform
| Inserts a new transform to the table at the given index position.
| is_registered
| Returns true if this table has been registered.
| remove_transform
| Removes the nth transform.
| set_transform
| Replaces the nth transform.
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Friends
class | VertexTransform

## Additional Inherited Members
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

Stores the total set of VertexTransforms that the vertices in a particular GeomVertexData object might depend on.

This structure is used for a GeomVertexData set up to compute its dynamic vertices on the graphics card. See TransformBlendTable for one set up to compute its dynamic vertices on the CPU.

Definition at line 38 of file transformTable.h.

## Constructor & Destructor Documentation

## ◆ TransformTable() [1/2]

TransformTable::TransformTable | ( |  | ) |

Definition at line 23 of file transformTable.cxx.

## ◆ TransformTable() [2/2]

TransformTable::TransformTable | ( | const TransformTable & | copy | ) |

Definition at line 32 of file transformTable.cxx.

## ◆ ~TransformTable()

TransformTable::~TransformTable | ( |  | ) |
| virtual

Definition at line 51 of file transformTable.cxx.

## Member Function Documentation

## ◆ add_transform()

size_t TransformTable::add_transform | ( | const VertexTransform * | transform | ) |

Adds a new transform to the table and returns the index number of the new transform.

Only valid for unregistered tables.

This does not automatically uniquify the pointer; if the transform is already present in the table, it will be added twice.

Definition at line 102 of file transformTable.cxx.

## ◆ complete_pointers()

int TransformTable::complete_pointers | ( | TypedWritable ** | p_list,
|  | BamReader * | manager )
| virtual

Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().

Returns the number of pointers processed.

Reimplemented from TypedWritable.

Definition at line 182 of file transformTable.cxx.

References TypedWritable::complete_pointers().

## ◆ force_init_type()

virtual TypeHandle TransformTable::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from TypedWritableReferenceCount.

Definition at line 116 of file transformTable.h.

## ◆ get_class_type()

static TypeHandle TransformTable::get_class_type | ( |  | ) |
| inline static

Definition at line 105 of file transformTable.h.

## ◆ get_type()

virtual TypeHandle TransformTable::get_type | ( |  | ) | const
| inline virtual

Reimplemented from TypedWritableReferenceCount.

Definition at line 113 of file transformTable.h.

## ◆ init_type()

static void TransformTable::init_type | ( |  | ) |
| inline static

Definition at line 108 of file transformTable.h.

## ◆ operator=()

void TransformTable::operator= | ( | const TransformTable & | copy | ) |

Definition at line 42 of file transformTable.cxx.

## ◆ register_with_read_factory()

void TransformTable::register_with_read_factory | ( |  | ) |
| static

Tells the BamReader how to create objects of type TransformTable.

Definition at line 155 of file transformTable.cxx.

References BamReader::get_factory(), and Factory< Type >::register_factory().

## ◆ write()

void TransformTable::write | ( | std::ostream & | out | ) | const

Definition at line 113 of file transformTable.cxx.

## ◆ write_datagram()

void TransformTable::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg )
| virtual

Writes the contents of this object to the datagram for shipping out to a Bam file.

Reimplemented from TypedWritable.

Definition at line 164 of file transformTable.cxx.

References Datagram::add_uint16(), BamWriter::write_cdata(), TypedWritable::write_datagram(), and BamWriter::write_pointer().

## Friends And Related Symbol Documentation

## ◆ VertexTransform

friend class VertexTransform
| friend

Definition at line 121 of file transformTable.h.

## Member Data Documentation

## ◆ get_modified

UpdateSeq TransformTable::get_modified
| inline

Returns a sequence number that's guaranteed to change at least when any VertexTransforms in the table change.

(However, this is only true for a registered table. An unregistered table may or may not reflect an update here when a VertexTransform changes.)

Definition at line 61 of file transformTable.h.

## ◆ get_num_transforms

size_t TransformTable::get_num_transforms
| inline

Returns the number of transforms in the table.

Definition at line 50 of file transformTable.h.

Referenced by DXGraphicsStateGuardian9::begin_draw_primitives().

## ◆ get_transform

const VertexTransform * TransformTable::get_transform
| inline

Returns the nth transform in the table.

Definition at line 50 of file transformTable.h.

Referenced by DXGraphicsStateGuardian9::begin_draw_primitives().

## ◆ insert_transform

void TransformTable::insert_transform

Inserts a new transform to the table at the given index position.

If the index is beyond the end of the table, appends it to the end. Only valid for unregistered tables.

This does not automatically uniquify the pointer; if the transform is already present in the table, it will be added twice.

Definition at line 63 of file transformTable.h.

## ◆ is_registered

bool TransformTable::is_registered
| inline

Returns true if this table has been registered.

Once it has been registered, the set of transforms in a TransformTable may not be further modified; but it must be registered before it can be assigned to a Geom.

Definition at line 60 of file transformTable.h.

Referenced by CPT().

## ◆ remove_transform

void TransformTable::remove_transform

Removes the nth transform.

Only valid for unregistered tables.

Definition at line 63 of file transformTable.h.

## ◆ set_transform

void TransformTable::set_transform

Replaces the nth transform.

Only valid for unregistered tables.

Definition at line 63 of file transformTable.h.

The documentation for this class was generated from the following files:

- panda/src/gobj/transformTable.h
- panda/src/gobj/transformTable.cxx
- panda/src/gobj/transformTable.I